# ncurses 6.0 - patch 20150711 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.0 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.0 are in the subdirectory
# 	ftp://invisible-island.net/ncurses/6.0
#
# ------------------------------------------------------------------------------
# ftp://invisible-island.net/ncurses/5.9/ncurses-6.0-20150711.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Jul 12 01:32:50 UTC 2015
# ------------------------------------------------------------------------------
# NEWS                             |   11 ++
# VERSION                          |    2 
# dist.mk                          |    4 -
# package/debian-mingw/changelog   |    4 -
# package/debian-mingw64/changelog |    4 -
# package/debian/changelog         |    4 -
# package/debian/control           |    9 ++
# package/debian/rules             |  147 +++++++++++++++++++++++++++---------
# package/mingw-ncurses.nsi        |    4 -
# package/mingw-ncurses.spec       |    2 
# package/ncurses.spec             |    2 
# package/ncursest.map             |    4 -
# package/ncursest.sym             |    3 
# package/ncursestw.map            |    4 -
# package/ncursestw.sym            |    3 
# progs/dump_entry.c               |    8 +-
# test/demo_termcap.c              |  140 +++++++++++++++++++++--------------
# test/demo_terminfo.c             |    8 +-
# test/package/debian/control      |   10 ++
# test/package/debian/rules        |  148 +++++++++++++++++++++++++++----------
# 20 files changed, 364 insertions(+), 157 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.2451 
--- ncurses-6.0-20150704+/NEWS	2015-07-04 21:01:57.000000000 +0000
+++ ncurses-6.0-20150711/NEWS	2015-07-11 22:54:54.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.2451 2015/07/04 21:01:57 tom Exp $
+-- $Id: NEWS,v 1.2455 2015/07/11 22:54:54 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,15 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20150711
+	+ modify scripts to build/use test-packages for the pthreads
+	  configuration of ncurses6.
+	+ add references to ttytype and termcap symbols in demo_terminfo.c and
+	  demo_termcap.c to ensure that when building ncursest.map, etc., that
+	  the corresponding names such as _nc_ttytype are added to the list of
+	  versioned symbols (report by Werner Fink)
+	+ fix regression from 20150704 (report/patch by Werner Fink).
+
 20150704
 	+ fix a few problems reported by Coverity.
 	+ fix comparison against "/usr/include" in misc/gen-pkgconfig.in
Index: VERSION
--- ncurses-6.0-20150704+/VERSION	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/VERSION	2015-07-07 08:04:53.000000000 +0000
@@ -1 +1 @@
-5:0:9	6.0	20150704
+5:0:9	6.0	20150711
Index: dist.mk
Prereq:  1.1058 
--- ncurses-6.0-20150704+/dist.mk	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/dist.mk	2015-07-07 08:04:53.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1058 2015/07/03 23:28:48 tom Exp $
+# $Id: dist.mk,v 1.1059 2015/07/07 08:04:53 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 0
-NCURSES_PATCH = 20150704
+NCURSES_PATCH = 20150711
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: package/debian-mingw/changelog
--- ncurses-6.0-20150704+/package/debian-mingw/changelog	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/debian-mingw/changelog	2015-07-07 08:04:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20150704) unstable; urgency=low
+ncurses6 (6.0+20150711) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 03 Jul 2015 19:28:49 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 07 Jul 2015 04:04:53 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.0-20150704+/package/debian-mingw64/changelog	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/debian-mingw64/changelog	2015-07-07 08:04:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20150704) unstable; urgency=low
+ncurses6 (6.0+20150711) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 03 Jul 2015 19:28:49 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 07 Jul 2015 04:04:53 -0400
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.0-20150704+/package/debian/changelog	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/debian/changelog	2015-07-07 08:04:53.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.0+20150704) unstable; urgency=low
+ncurses6 (6.0+20150711) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Fri, 03 Jul 2015 19:28:48 -0400
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Tue, 07 Jul 2015 04:04:53 -0400
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/debian/control
--- ncurses-6.0-20150704+/package/debian/control	2012-06-08 13:29:14.000000000 +0000
+++ ncurses-6.0-20150711/package/debian/control	2015-07-11 20:29:30.000000000 +0000
@@ -14,3 +14,12 @@
  updating character screens with reasonable optimization.
  .
  This package is used for testing ABI 6.
+
+Package: ncursest6
+Architecture: any
+Depends: ${misc:Depends}
+Description: shared libraries for terminal handling
+ The ncurses library routines are a terminal-independent method of
+ updating character screens with reasonable optimization.
+ .
+ This package is used for testing ABI 6 with pthreads.
Index: package/debian/rules
--- ncurses-6.0-20150704+/package/debian/rules	2015-05-31 15:42:28.000000000 +0000
+++ ncurses-6.0-20150711/package/debian/rules	2015-07-11 22:42:03.000000000 +0000
@@ -6,6 +6,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+# packages
+PACKAGES.indep = # ncurses6-docs
+PACKAGES.arch  = ncurses6 ncursest6
+
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
@@ -17,7 +21,8 @@
 MY_ABI=6
 MY_DIR=/usr
 MYDATA=/usr/local/ncurses/share/terminfo
-BUILD_DIR=$(CURDIR)/debian/ncurses$(MY_ABI)
+NORMAL_DIR=$(CURDIR)/debian/ncurses$(MY_ABI)
+THREAD_DIR=$(CURDIR)/debian/ncursest$(MY_ABI)
 
 CFLAGS   = $(shell dpkg-buildflags --get CFLAGS) $(CC_NORMAL)
 CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
@@ -40,15 +45,13 @@
         INSTALL_PROGRAM += -s
 endif
 
+verbose = # -v
 
-configure: configure-stamp
-configure-stamp:
-	dh_testdir
-
+configure = \
 	$(RPATH_ENV) \
 	CFLAGS="$(CFLAGS)" \
 	CPPFLAGS="$(CPPFLAGS)" \
-	LDFLAGS="$(LDFLAGS)" ./configure $(RPATH_OPT) \
+	LDFLAGS="$(LDFLAGS)" ../../configure $(RPATH_OPT) \
 		--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
 		--prefix=$(MY_DIR) \
@@ -81,58 +84,124 @@
 		--without-debug \
 		--without-normal
 
-	touch configure-stamp
+NCURSES6_DIR = $(CURDIR)/debian/ncurses6
+NCURSEST6_DIR = $(CURDIR)/debian/ncursest6
 
-build: build-stamp
-build-stamp: configure-stamp
+.PHONY: all config build install binary clean config-indep config-arch \
+    build-indep build-arch install-indep install-arch binary-indep \
+    binary-arch
+
+all: build
+
+config: config-indep config-arch
+build: build-indep build-arch
+install: install-indep install-arch
+binary: binary-indep binary-arch
+clean:
 	dh_testdir
+	dh_testroot
+	dh_clean $(verbose)
+	rm -rf t
 
-	$(MAKE)
+config-indep: $(PACKAGES.indep:%=config-%-stamp)
+config-arch: $(PACKAGES.arch:%=config-%-stamp)
 
-	touch build-stamp
+build-indep: $(PACKAGES.indep:%=build-%-stamp)
+build-arch: $(PACKAGES.arch:%=build-%-stamp)
 
-clean:
+install-indep: $(PACKAGES.indep:%=install-%-stamp)
+install-arch: $(PACKAGES.arch:%=install-%-stamp)
+
+config-ncurses6-stamp:
+	dh_testdir
+	rm -rf t/ncurses6
+	mkdir -p t/ncurses6
+	cd t/ncurses6; $(configure)
+	touch $@
+
+config-ncursest6-stamp:
+	dh_testdir
+	rm -rf t/ncursest6
+	mkdir -p t/ncursest6
+	cd t/ncursest6; $(configure) \
+		--enable-interop \
+		--enable-sp-funcs \
+		--program-suffix=t$(MY_ABI) \
+		--with-pthread
+	touch $@
+
+build-ncurses6-stamp: config-ncurses6-stamp
+	dh_testdir
+
+	$(MAKE) -C t/ncurses6
+
+	touch $@
+
+build-ncursest6-stamp: config-ncursest6-stamp
+	dh_testdir
+
+	$(MAKE) -C t/ncursest6
+
+	touch $@
+
+install-ncurses6-stamp: build-ncurses6-stamp
 	dh_testdir
 	dh_testroot
+	dh_installdirs $(verbose)
+	dh_prep        $(verbose) -pncurses6
 
-	[ ! -f makefile ] || $(MAKE) distclean
+	$(MAKE) -C t/ncurses6 install.libs install.progs DESTDIR=$(NCURSES6_DIR)
+	$(MAKE) -C t/ncurses6/test ncurses LOCAL_LIBDIR=$(MY_DIR)/lib
 
-	rm -f configure-stamp build-stamp install-stamp
+	mv t/ncurses6/test/ncurses $(NCURSES6_DIR)$(MY_DIR)/bin/ncurses$(MY_ABI)
 
-	dh_clean
+	touch $@
 
-install: install-stamp
-install-stamp: build-stamp
+install-ncursest6-stamp: build-ncursest6-stamp
 	dh_testdir
 	dh_testroot
-	dh_clean -k
-	dh_installdirs
+	dh_installdirs $(verbose)
+	dh_prep        $(verbose) -pncursest6
 
-	$(MAKE) install.libs install.progs DESTDIR=$(BUILD_DIR)
+	$(MAKE) -C t/ncursest6 install.libs install.progs DESTDIR=$(NCURSEST6_DIR)
+	$(MAKE) -C t/ncursest6/test ncurses LOCAL_LIBDIR=$(MY_DIR)/lib
 
-	( cd test && make ncurses LOCAL_LIBDIR=$(MY_DIR)/lib )
-	mv test/ncurses $(BUILD_DIR)$(MY_DIR)/bin/ncurses$(MY_ABI)
+	mv t/ncursest6/test/ncurses $(NCURSEST6_DIR)$(MY_DIR)/bin/ncursest$(MY_ABI)
 
-	touch install-stamp
+	touch $@
 
 # Build architecture-independent files here.
-binary-indep: build install
-# No binary-indep target.
+binary-indep: install-indep
+ifneq ($(PACKAGES.indep),)
+	rm -f $(PACKAGES.indep:%=install-%-stamp)
+	dh_testdir
+	dh_testroot
+	dh_installdocs       $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installman        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installexamples   $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installchangelogs $(verbose) $(PACKAGES.indep:%=-p%) NEWS
+	dh_compress          $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_fixperms          $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installdeb        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_gencontrol        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_md5sums           $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_builddeb          $(verbose) $(PACKAGES.indep:%=-p%)
+endif
 
 # Build architecture-dependent files here.
-binary-arch: build install
+binary-arch: install-arch
+ifneq ($(PACKAGES.arch),)
+	rm -f $(PACKAGES.arch:%=install-%-stamp)
 	dh_testdir
 	dh_testroot
-	dh_installchangelogs NEWS
-	dh_strip
-	dh_compress
-	dh_fixperms
-	dh_installdeb
-	dh_makeshlibs
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-
-binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install install-stamp
+	dh_installchangelogs $(verbose) $(PACKAGES.arch:%=-p%)  NEWS
+	dh_strip             $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_compress          $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_fixperms          $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_installdeb        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_makeshlibs        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_shlibdeps         $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_gencontrol        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_md5sums           $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_builddeb          $(verbose) $(PACKAGES.arch:%=-p%)
+endif
Index: package/mingw-ncurses.nsi
Prereq:  1.111 
--- ncurses-6.0-20150704+/package/mingw-ncurses.nsi	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/mingw-ncurses.nsi	2015-07-07 08:04:53.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.111 2015/07/03 23:28:48 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.112 2015/07/07 08:04:53 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "0"
 !define VERSION_YYYY  "2015"
-!define VERSION_MMDD  "0704"
+!define VERSION_MMDD  "0711"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.0-20150704+/package/mingw-ncurses.spec	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/mingw-ncurses.spec	2015-07-07 08:04:53.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.0
-Release: 20150704
+Release: 20150711
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.0-20150704+/package/ncurses.spec	2015-07-03 23:28:48.000000000 +0000
+++ ncurses-6.0-20150711/package/ncurses.spec	2015-07-07 08:04:53.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.0
-Release: 20150704
+Release: 20150711
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncursest.map
Prereq:  1.29 
--- ncurses-6.0-20150704+/package/ncursest.map	2015-06-27 22:23:14.000000000 +0000
+++ ncurses-6.0-20150711/package/ncursest.map	2015-07-11 13:01:10.000000000 +0000
@@ -1,4 +1,4 @@
-# $Id: ncursest.map,v 1.29 2015/06/27 22:23:14 tom Exp $
+# $Id: ncursest.map,v 1.30 2015/07/11 13:01:10 tom Exp $
 # script for shared library symbol-versioning using ld
 #
 # This file was generated by ncu-mapsyms
@@ -362,13 +362,13 @@
 		_nc_strfnames;
 		_nc_strnames;
 		_nc_tracechar;
+		_nc_ttytype;
 		_nc_use_tracef;
 		set_tabsize;
 	local:
 		_nc__nc_tputs_trace;
 		_nc_keyname;
 		_nc_mutex_init;
-		_nc_ttytype;
 		_nc_unctrl;
 } NCURSES_TINFO_5.6.20061217;
 
Index: package/ncursest.sym
Prereq:  1.24 
--- ncurses-6.0-20150704+/package/ncursest.sym	2015-06-27 22:30:00.000000000 +0000
+++ ncurses-6.0-20150711/package/ncursest.sym	2015-07-11 23:33:50.000000000 +0000
@@ -1,4 +1,4 @@
-# $Id: ncursest.sym,v 1.24 2015/06/27 22:30:00 tom Exp $
+# $Id: ncursest.sym,v 1.25 2015/07/11 23:33:50 tom Exp $
 # script for shared library symbol-visibility using libtool
 #
 # This file was generated by ncu-mapsyms
@@ -222,6 +222,7 @@
 _nc_tracing
 _nc_trans_string
 _nc_trim_sgr0
+_nc_ttytype
 _nc_unicode_locale
 _nc_update_screensize
 _nc_use_tracef
Index: package/ncursestw.map
Prereq:  1.30 
--- ncurses-6.0-20150704+/package/ncursestw.map	2015-06-27 22:27:57.000000000 +0000
+++ ncurses-6.0-20150711/package/ncursestw.map	2015-07-11 13:02:44.000000000 +0000
@@ -1,4 +1,4 @@
-# $Id: ncursestw.map,v 1.30 2015/06/27 22:27:57 tom Exp $
+# $Id: ncursestw.map,v 1.31 2015/07/11 13:02:44 tom Exp $
 # script for shared library symbol-versioning using ld
 #
 # This file was generated by ncu-mapsyms
@@ -362,6 +362,7 @@
 		_nc_strfnames;
 		_nc_strnames;
 		_nc_tracechar;
+		_nc_ttytype;
 		_nc_use_tracef;
 		_nc_viswbuf;
 		_nc_viswbufn;
@@ -373,7 +374,6 @@
 		_nc__nc_tputs_trace;
 		_nc_keyname;
 		_nc_mutex_init;
-		_nc_ttytype;
 		_nc_unctrl;
 		_nc_viswbuf2;
 } NCURSES_TINFO_5.6.20061217;
Index: package/ncursestw.sym
Prereq:  1.22 
--- ncurses-6.0-20150704+/package/ncursestw.sym	2015-06-27 22:29:28.000000000 +0000
+++ ncurses-6.0-20150711/package/ncursestw.sym	2015-07-11 23:33:35.000000000 +0000
@@ -1,4 +1,4 @@
-# $Id: ncursestw.sym,v 1.22 2015/06/27 22:29:28 tom Exp $
+# $Id: ncursestw.sym,v 1.23 2015/07/11 23:33:35 tom Exp $
 # script for shared library symbol-visibility using libtool
 #
 # This file was generated by ncu-mapsyms
@@ -222,6 +222,7 @@
 _nc_tracing
 _nc_trans_string
 _nc_trim_sgr0
+_nc_ttytype
 _nc_unicode_locale
 _nc_update_screensize
 _nc_use_tracef
Index: progs/dump_entry.c
Prereq:  1.117 
--- ncurses-6.0-20150704+/progs/dump_entry.c	2015-07-05 00:01:04.000000000 +0000
+++ ncurses-6.0-20150711/progs/dump_entry.c	2015-07-07 08:06:39.000000000 +0000
@@ -39,7 +39,7 @@
 #include "termsort.c"		/* this C file is generated */
 #include <parametrized.h>	/* so is this */
 
-MODULE_ID("$Id: dump_entry.c,v 1.117 2015/07/05 00:01:04 tom Exp $")
+MODULE_ID("$Id: dump_entry.c,v 1.118 2015/07/07 08:06:39 Werner.Fink Exp $")
 
 #define INDENT			8
 #define DISCARD(string) string = ABSENT_STRING
@@ -778,8 +778,10 @@
 		    trimmed_sgr0 = _nc_trim_sgr0(tterm);
 		    if (strcmp(capability, trimmed_sgr0))
 			capability = trimmed_sgr0;
-		    else
-			free(trimmed_sgr0);
+		    else {
+			if (trimmed_sgr0 != exit_attribute_mode)
+			    free(trimmed_sgr0);
+		    }
 
 		    set_attributes = my_sgr;
 		}
Index: test/demo_termcap.c
Prereq:  1.46 
--- ncurses-6.0-20150704+/test/demo_termcap.c	2014-10-10 00:35:43.000000000 +0000
+++ ncurses-6.0-20150711/test/demo_termcap.c	2015-07-10 23:36:16.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2005-2013,2014 Free Software Foundation, Inc.              *
+ * Copyright (c) 2005-2014,2015 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /*
  * Author: Thomas E. Dickey
  *
- * $Id: demo_termcap.c,v 1.46 2014/10/10 00:35:43 tom Exp $
+ * $Id: demo_termcap.c,v 1.47 2015/07/10 23:36:16 tom Exp $
  *
  * A simple demo of the termcap interface.
  */
@@ -46,6 +46,10 @@
 #endif
 #endif
 
+#ifdef NCURSES_VERSION
+#include <termcap.h>
+#endif
+
 static void
 failed(const char *msg)
 {
@@ -163,6 +167,72 @@
 }
 
 static void
+show_string(const char *name, const char *value)
+{
+    printf(FNAME(str), name);
+    if (value == ((char *) -1)) {
+	printf("CANCELLED");
+    } else if (value == ((char *) 0)) {
+	printf("ABSENT");
+    } else {
+	while (*value != 0) {
+	    int ch = UChar(*value++);
+	    switch (ch) {
+	    case '\177':
+		fputs("^?", stdout);
+		break;
+	    case '\033':
+		fputs("\\E", stdout);
+		break;
+	    case '\b':
+		fputs("\\b", stdout);
+		break;
+	    case '\f':
+		fputs("\\f", stdout);
+		break;
+	    case '\n':
+		fputs("\\n", stdout);
+		break;
+	    case '\r':
+		fputs("\\r", stdout);
+		break;
+	    case ' ':
+		fputs("\\s", stdout);
+		break;
+	    case '\t':
+		fputs("\\t", stdout);
+		break;
+	    case '^':
+		fputs("\\^", stdout);
+		break;
+	    case ':':
+		fputs("\\072", stdout);
+		break;
+	    case '\\':
+		fputs("\\\\", stdout);
+		break;
+	    default:
+		if (isgraph(ch))
+		    fputc(ch, stdout);
+		else if (ch < 32)
+		    printf("^%c", ch + '@');
+		else
+		    printf("\\%03o", ch);
+		break;
+	    }
+	}
+    }
+    printf("\n");
+}
+
+static void
+show_number(const char *name, int value)
+{
+    printf(FNAME(num), name);
+    printf(" %d\n", value);
+}
+
+static void
 dumpit(NCURSES_CONST char *cap)
 {
     /*
@@ -184,61 +254,13 @@
 	     * Note that the strings returned are mostly terminfo format, since
 	     * ncurses does not convert except for a handful of special cases.
 	     */
-	    printf(FNAME(str), cap);
-	    while (*str != 0) {
-		int ch = UChar(*str++);
-		switch (ch) {
-		case '\177':
-		    fputs("^?", stdout);
-		    break;
-		case '\033':
-		    fputs("\\E", stdout);
-		    break;
-		case '\b':
-		    fputs("\\b", stdout);
-		    break;
-		case '\f':
-		    fputs("\\f", stdout);
-		    break;
-		case '\n':
-		    fputs("\\n", stdout);
-		    break;
-		case '\r':
-		    fputs("\\r", stdout);
-		    break;
-		case ' ':
-		    fputs("\\s", stdout);
-		    break;
-		case '\t':
-		    fputs("\\t", stdout);
-		    break;
-		case '^':
-		    fputs("\\^", stdout);
-		    break;
-		case ':':
-		    fputs("\\072", stdout);
-		    break;
-		case '\\':
-		    fputs("\\\\", stdout);
-		    break;
-		default:
-		    if (isgraph(ch))
-			fputc(ch, stdout);
-		    else if (ch < 32)
-			printf("^%c", ch + '@');
-		    else
-			printf("\\%03o", ch);
-		    break;
-		}
-	    }
-	    printf("\n");
+	    show_string(cap, str);
 	}
     } else if ((num = tgetnum(cap)) >= 0) {
 	total_values++;
 	total_n_values++;
 	if (!q_opt) {
-	    printf(FNAME(num), cap);
-	    printf(" %d\n", num);
+	    show_number(cap, num);
 	}
     } else if (tgetflag(cap) > 0) {
 	total_values++;
@@ -712,6 +734,7 @@
 	" -q       quiet (prints only counts)",
 	" -r COUNT repeat for given count",
 	" -s       print string-capabilities",
+	" -v       print termcap-variables",
 #ifdef NCURSES_VERSION
 	" -x       print extended capabilities",
 #endif
@@ -729,12 +752,13 @@
     int n;
     char *name;
     bool a_opt = FALSE;
+    bool v_opt = FALSE;
     char *input_name = 0;
 
     int repeat;
     int r_opt = 1;
 
-    while ((n = getopt(argc, argv, "abd:e:i:nqr:sxy")) != -1) {
+    while ((n = getopt(argc, argv, "abd:e:i:nqr:svxy")) != -1) {
 	switch (n) {
 	case 'a':
 	    a_opt = TRUE;
@@ -764,6 +788,9 @@
 	case 's':
 	    s_opt = TRUE;
 	    break;
+	case 'v':
+	    v_opt = TRUE;
+	    break;
 #if NCURSES_XNAMES
 	case 'x':
 	    x_opt = TRUE;
@@ -836,6 +863,13 @@
     printf("%ld values (%ld booleans, %ld numbers, %ld strings)\n",
 	   total_values, total_b_values, total_n_values, total_s_values);
 
+    if (v_opt) {
+	show_number("PC", PC);
+	show_string("UP", UP);
+	show_string("BC", BC);
+	show_number("ospeed", ospeed);
+    }
+
     free_dblist();
 
     ExitProgram(EXIT_SUCCESS);
Index: test/demo_terminfo.c
Prereq:  1.38 
--- ncurses-6.0-20150704+/test/demo_terminfo.c	2014-10-10 00:35:28.000000000 +0000
+++ ncurses-6.0-20150711/test/demo_terminfo.c	2015-07-10 23:45:44.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2009-2013,2014 Free Software Foundation, Inc.              *
+ * Copyright (c) 2009-2014,2015 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -29,7 +29,7 @@
 /*
  * Author: Thomas E. Dickey
  *
- * $Id: demo_terminfo.c,v 1.38 2014/10/10 00:35:28 tom Exp $
+ * $Id: demo_terminfo.c,v 1.39 2015/07/10 23:45:44 tom Exp $
  *
  * A simple demo of the terminfo interface.
  */
@@ -266,6 +266,10 @@
     if (!q_opt)
 	printf("Terminal type \"%s\"\n", name);
     setupterm((NCURSES_CONST char *) name, 1, (int *) 0);
+    if (!q_opt) {
+	if (strcmp(name, ttytype))
+	    printf("... actual \"%s\"\n", ttytype);
+    }
 
     for (length = 1; length <= MAX_FORCE; ++length) {
 	/* set all digits to zeros */
Index: test/package/debian/control
--- ncurses-6.0-20150704+/test/package/debian/control	2011-03-25 00:59:15.000000000 +0000
+++ ncurses-6.0-20150711/test/package/debian/control	2015-07-11 22:48:33.000000000 +0000
@@ -14,3 +14,13 @@
  .
  This package installs in "bin/ncurses-examples" to avoid conflict with other
  packages.
+
+Package: ncursest-examples
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: ncurses-examples - example/test programs from ncurses
+ These are the example/test programs from the ncurses distribution, using
+ the thread configuration.
+ .
+ This package installs in "bin/ncursest-examples" to avoid conflict with other
+ packages.
Index: test/package/debian/rules
--- ncurses-6.0-20150704+/test/package/debian/rules	2015-04-25 10:55:30.000000000 +0000
+++ ncurses-6.0-20150711/test/package/debian/rules	2015-07-11 23:30:04.000000000 +0000
@@ -6,6 +6,13 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+# packages
+NCURSES_PKG = ncurses-examples
+NCURSEST_PKG = ncursest-examples
+
+PACKAGES.indep = # ncurses-examples-docs
+PACKAGES.arch  = $(NCURSES_PKG) $(NCURSEST_PKG)
+
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
@@ -22,69 +29,130 @@
         INSTALL_PROGRAM += -s
 endif
 
+verbose = # -v
 
-configure: configure-stamp
-configure-stamp:
-	dh_testdir
-
-	CFLAGS="$(CFLAGS)" ./configure \
+configure = \
+	CFLAGS="$(CFLAGS)" ../../configure \
 		--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
-		--bindir=\$${prefix}/bin/ncurses-examples \
 		--prefix=/usr \
-		--with-screen=ncursesw6 \
 		--disable-rpath-hack
 
-	touch configure-stamp
+.PHONY: all config build install binary clean config-indep config-arch \
+    build-indep build-arch install-indep install-arch binary-indep \
+    binary-arch
+
+all: build
+
+config: config-indep config-arch
+build: build-indep build-arch
+install: install-indep install-arch
+binary: binary-indep binary-arch
+clean:
+	dh_testdir
+	dh_testroot
+	dh_clean $(verbose)
+	rm -rf t
+
+config-indep: $(PACKAGES.indep:%=config-%-stamp)
+config-arch: $(PACKAGES.arch:%=config-%-stamp)
 
-build: build-stamp
-build-stamp: configure-stamp
+build-indep: $(PACKAGES.indep:%=build-%-stamp)
+build-arch: $(PACKAGES.arch:%=build-%-stamp)
+
+install-indep: $(PACKAGES.indep:%=install-%-stamp)
+install-arch: $(PACKAGES.arch:%=install-%-stamp)
+
+config-$(NCURSES_PKG)-stamp:
 	dh_testdir
 
-	$(MAKE)
+	rm -rf t/ncurses6
+	mkdir -p t/ncurses6
 
-	touch build-stamp
+	cd t/ncurses6; $(configure) \
+		--bindir=\$${prefix}/bin/$(NCURSES_PKG) \
+		--with-screen=ncursesw6
 
-clean:
+	touch $@
+
+config-$(NCURSEST_PKG)-stamp:
 	dh_testdir
-	dh_testroot
 
-	[ ! -f makefile ] || $(MAKE) distclean
+	rm -rf t/ncursest6
+	mkdir -p t/ncursest6
 
-	rm -f configure-stamp build-stamp install-stamp
+	cd t/ncursest6; $(configure) \
+		--bindir=\$${prefix}/bin/$(NCURSEST_PKG) \
+		--with-screen=ncursestw6
 
-	dh_clean
+	touch $@
 
-install: install-stamp
-install-stamp: build-stamp
+build-$(NCURSES_PKG)-stamp: config-$(NCURSES_PKG)-stamp
+	dh_testdir
+
+	$(MAKE) -C t/ncurses6
+
+	touch $@
+
+build-$(NCURSEST_PKG)-stamp: config-$(NCURSEST_PKG)-stamp
+	dh_testdir
+
+	$(MAKE) -C t/ncursest6
+
+	touch $@
+
+install-$(NCURSES_PKG)-stamp: build-$(NCURSES_PKG)-stamp
+	dh_testdir
+	dh_testroot
+	dh_installdirs $(verbose)
+	dh_prep        $(verbose) -p$(NCURSES_PKG)
+
+	$(MAKE) -C t/ncurses6 install DESTDIR=$(CURDIR)/debian/$(NCURSES_PKG)
+
+	touch $@
+
+install-$(NCURSEST_PKG)-stamp: build-$(NCURSEST_PKG)-stamp
 	dh_testdir
 	dh_testroot
-	dh_clean -k
-	dh_installdirs
+	dh_installdirs $(verbose)
+	dh_prep        $(verbose) -p$(NCURSEST_PKG)
 
-	$(MAKE) install DESTDIR=$(CURDIR)/debian/ncurses-examples
+	$(MAKE) -C t/ncursest6 install DESTDIR=$(CURDIR)/debian/$(NCURSEST_PKG)
 
-	touch install-stamp
+	touch $@
 
 # Build architecture-independent files here.
-binary-indep: build install
-# No binary-indep target.
+binary-indep: install-indep
+ifneq ($(PACKAGES.indep),)
+	rm -f $(PACKAGES.indep:%=install-%-stamp)
+	dh_testdir
+	dh_testroot
+	dh_installdocs       $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installman        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installexamples   $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installchangelogs $(verbose) $(PACKAGES.indep:%=-p%) NEWS
+	dh_compress          $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_fixperms          $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_installdeb        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_gencontrol        $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_md5sums           $(verbose) $(PACKAGES.indep:%=-p%)
+	dh_builddeb          $(verbose) $(PACKAGES.indep:%=-p%)
+endif
 
 # Build architecture-dependent files here.
-binary-arch: build install
+binary-arch: install-arch
+ifneq ($(PACKAGES.arch),)
+	rm -f $(PACKAGES.arch:%=install-%-stamp)
 	dh_testdir
 	dh_testroot
-	dh_installdocs
-	dh_installexamples
-	dh_installchangelogs NEWS
-	dh_strip
-	dh_compress
-	dh_fixperms
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-
-binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary install install-stamp
+	dh_installchangelogs $(verbose) $(PACKAGES.arch:%=-p%)  NEWS
+	dh_strip             $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_compress          $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_fixperms          $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_installdeb        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_makeshlibs        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_shlibdeps         $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_gencontrol        $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_md5sums           $(verbose) $(PACKAGES.arch:%=-p%)
+	dh_builddeb          $(verbose) $(PACKAGES.arch:%=-p%)
+endif
